#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2016/08/21
#Last Modify: 2016/08/22
'''
A replacement for my bash timer script, timer.sh
'''
#TODO: better variable names
# layout
# hide title bar DONE
#  disables esc to close
# icon
# highlight tab order
import commands #use aplay to play sound
import sys #argv for qt
from PyQt4 import QtGui, QtCore
import time #asctime

END_SOUND = "/home/egg/.sounds/quiet_river_done.wav"

class myDialog(QtGui.QDialog):
  '''The 'main' timer window'''
  def __init__(self, parent=None):
    super(myDialog, self).__init__(parent)
    #variables
    self.counter = 0 #counter
    self.flag = False #flag for counting or not
    #text inputs
    self.inp = QtGui.QLineEdit("0")
    self.connect(self.inp, QtCore.SIGNAL("returnPressed()"), self.sleepTimerOn) 
    self.note = QtGui.QLineEdit("Note")
    self.connect(self.note, QtCore.SIGNAL("returnPressed()"), self.sleepTimerOn) 
    #buttons
    #NOTE this button has no purpose, without it the first button created is
    # called after sleepTimerOn, no idea...
    #NOTE now that i've broken sleep into 2 functions, this is required to not 
    # start the counter when a non-int is entered...
    #NOTE adding a quit button seems to work...
    self.countbtn = QtGui.QPushButton("Quit", self)
    #TODO how to link to esc?
    self.connect(self.countbtn, QtCore.SIGNAL("escapePressed()"), self.quit) 
    #self.countbtn.hide()
    self.countbtn.clicked.connect(self.quit)
    self.startbtn = QtGui.QPushButton("On/Off", self)
    self.startbtn.clicked.connect(self.countToggle)
    self.sleepbtn = QtGui.QPushButton("Sleep", self)
    self.sleepbtn.clicked.connect(self.sleepTimerOn)
    #labels
    self.msgLbl = QtGui.QLabel("")
    t = self.formatTime(self.counter)
    self.counterLbl = QtGui.QLabel(
		   "<font color=white size=6 style='font-family:Monospace;'><b>"
                   +str(t)+
                   "</b></font>")
    #grid
    grid = QtGui.QGridLayout()
    grid.addWidget(self.counterLbl, 1, 2) #matplot like coords
    #TODO better layout for changing label size
    grid.addWidget(self.msgLbl, 1, 1) #matplot like coords
    grid.addWidget(self.inp, 1, 4) #matplot like coords
    grid.addWidget(self.note, 2, 1) #matplot like coords
    grid.addWidget(self.countbtn, 2, 2)
    grid.addWidget(self.startbtn, 2, 3)
    grid.addWidget(self.sleepbtn, 2, 4)
    self.setLayout(grid)

    self.setWindowTitle("Tick tock mother fucker")
    self.inp.setFocus()
    self.show()

  def sleepTimerOn(self):
    '''Connected to sleepbtn and inp box. 
    Hides the window and sleeps.'''
    #print self.flag, "1"
    self.startTime = time.asctime().split()[3]
    try:
      t = int(self.inp.displayText()) #get input
      self.hide() #if successful in converting to input to int
      QtCore.QTimer.singleShot(t*60*1000, self.sleepTimerOff) #wait milliseconds then..loop
    except:
      sys.exit() #input was not an int
    finally:
      self.inp.setFocus()

  def sleepTimerOff(self):
    '''Called from sleepTimerOn
    Resets counter when it wakes up.'''
    self.stopTime = time.asctime().split()[3]
    msg = "Slept {} mins\n{}\n{}".format(self.inp.displayText(),
      self.startTime, self.stopTime)
    self.msgLbl.setText(msg)
    self.counter = 0 #start counting up from 0 after timer expires
    #print self.flag, "2"
    if self.flag == False:
      self.countToggle()
    commands.getoutput("aplay "+END_SOUND)
    self.show()
    #print self.flag, "7"

  def countToggle(self):
    '''Connected to startbtn'''
    #print self.flag, "3" 
    self.flag = not self.flag
    if self.flag:
      self.countUp()
    #print self.flag, "6"

  def countUp(self):
    '''Counting loop'''
    #print self.flag, "4"
    if self.flag:
      self.counter+=1
      if not self.counter%300:
	print "minute passed"
	commands.getoutput("aplay "+END_SOUND)
      t = self.formatTime(self.counter)
      self.counterLbl.setText(
                    "<font color=white size=6 style='font-family:Monospace'><b>"
                    +str(t)+
                    "</b></font>")
      QtCore.QTimer.singleShot(1000, self.countUp) #counts the (milli)seconds
    #print self.flag, "5"

  def formatTime(self, t):
    '''Helper to display nicely formatted times'''
    minutes = t/60
    seconds = t%60
    if seconds < 10:
      seconds = "0"+str(seconds)
    return str(minutes)+":"+str(seconds)

  def quit(self):
    sys.exit()

def main():
  app = QtGui.QApplication(sys.argv)
  myDia = myDialog()
  #TODO hide titlebar
  # add icon
  #TODO highlight selected element w/ tab
  #myDia.setWindowFlags(QtCore.Qt.SplashScreen) #hides the default titlebar
  #TODO center window on screen and link esc
  #TODO spacebar to start/stop button
  myDia.show()
  app.exec_()
  

if __name__ == '__main__':
  main()

